# vmware_dvs_portgroup_find – Find portgroup(s) in a VMware environment

New in version 2.9.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Find portgroup(s) based on different criteria such as distributed vSwitch, VLAN id or a string in the name.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.7
- PyVmomi

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
dvswitch string |  | Name of a distributed vSwitch to look for.
hostname string |  | The hostname or IP address of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_HOST` will be used instead. Environment variable support added in Ansible 2.6.
name string |  | string to check inside the name of the portgroup. Basic containment check using python `in` operation.
password string |  | The password of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_PASSWORD` will be used instead. Environment variable support added in Ansible 2.6. aliases: pass, pwd
port integer added in 2.5 | Default: 443 | The port number of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_PORT` will be used instead. Environment variable support added in Ansible 2.6.
proxy_host string added in 2.9 |  | Address of a proxy that will receive all HTTPS requests and relay them. The format is a hostname or a IP. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_HOST` will be used instead. This feature depends on a version of pyvmomi greater than v6.7.1.2018.12
proxy_port integer added in 2.9 |  | Port of the HTTP proxy that will receive all HTTPS requests and relay them. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_PORT` will be used instead.

show_uplink
boolean

Choices:
- no ←
- yes

Show or hide uplink portgroups.
Only relevant when `vlanid` is supplied.

username string |  | The username of the vSphere vCenter or ESXi server. If the value is not specified in the task, the value of environment variable `VMWARE_USER` will be used instead. Environment variable support added in Ansible 2.6. aliases: admin, user

validate_certs
boolean

Choices:
- no
- yes ←

Allows connection when SSL certificates are not valid. Set to `false` when certificates are not trusted.
If the value is not specified in the task, the value of environment variable `VMWARE_VALIDATE_CERTS` will be used instead.
Environment variable support added in Ansible 2.6.
If set to `yes`, please make sure Python >= 2.7.9 is installed on the given machine.

vlanid integer |  | VLAN id can be any number between 1 and 4094. This search criteria will looks into VLAN ranges to find possible matches.

## Notes

Note

- Tested on vSphere 6.5

## Examples

    - name: Get all portgroups in dvswitch vDS
      vmware_dvs_portgroup_find:
        hostname: "{{ vcenter_hostname }}"
        username: "{{ vcenter_username }}"
        password: "{{ vcenter_password }}"
        dvswitch: 'vDS'
        validate_certs: no
      delegate_to: localhost

    - name: Confirm if vlan 15 is present
      vmware_dvs_portgroup_find:
        hostname: "{{ vcenter_hostname }}"
        username: "{{ vcenter_username }}"
        password: "{{ vcenter_password }}"
        vlanid: '15'
        validate_certs: no
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
dvs_portgroups list | on success | basic details of portgroups found Sample: [{'dvswitch': 'vDS', 'name': 'N-51', 'pvlan': True, 'trunk': True, 'vlan_id': '0'}]

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- David Martinez (@dx0xm)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.